import 'package:fis_jsonrpc/services/notification.m.dart'
    show NotificationTypeEnum;

export 'package:fis_jsonrpc/services/notification.m.dart'
    show MessageTypeEnum, NotificationTypeEnum, NotifyMessage;

abstract class JsonRpcNotificationHandlerBase {
  JsonRpcNotificationHandlerBase(this.type, {this.order = 0});

  /// Remote notification type.
  final NotificationTypeEnum type;

  /// For set order of handling notification.
  final int order;

  /// Handle notification.
  ///
  /// [message] The message content of notification.
  Future<void> handle(String? message);
}
