import 'dart:core';

import 'package:fis_jsonrpc/client_base.dart';

import 'notification.m.dart';


class NotificationService extends JsonRpcClientBase {
	NotificationService(
		String host, {
		String serviceName = "INotificationService",
		Map<String, String>? headers,
		int? timeout,
	}) : super(
						host,
						serviceName,
						headers: headers,
						timeout: timeout,
				);

	Future<bool> addNotificationToQueueAsync(SendNotificationRequest request) async {
		var rpcRst = await call("AddNotificationToQueueAsync", request);
		return rpcRst;
	}

	Future<bool> subscribeNotifyAsync(SubscribeNotifyRequest request) async {
		var rpcRst = await call("SubscribeNotifyAsync", request);
		return rpcRst;
	}

	Future<bool> sendNotificationAsync(SendNotificationRequest request) async {
		var rpcRst = await call("SendNotificationAsync", request);
		return rpcRst;
	}

}

